Attribute VB_Name = "mdlMidiOut"
'=======================
' @̡Gd妨
'=======================

Option Explicit

Private Declare Function midiOutGetDevCaps Lib "winmm.dll" Alias "midiOutGetDevCapsA" (ByVal uDeviceID As Long, lpCaps As MidiOutCaps, ByVal uSize As Long) As Long
Private Declare Function midiOutGetNumDevs Lib "winmm.dll" () As Integer
Private Declare Function midiOutOpen Lib "winmm.dll" (lphMidiOut As Long, ByVal uDeviceID As Long, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
Private Declare Function midiOutClose Lib "winmm.dll" (ByVal hMidiOut As Long) As Long
Private Declare Function midiOutShortMsg Lib "winmm.dll" (ByVal hMidiOut As Long, ByVal dwMsg As Long) As Long
Private Declare Function midiOutGetErrorText Lib "winmm.dll" Alias "midiOutGetErrorTextA" (ByVal err As Long, ByVal lpText As String, ByVal uSize As Long) As Long

Private Const maxErrorLength = 256
Private Const midiDefault = -1              'w] Midi ]ƥNX
Private Const MIDI_EVENT_NOTE_ON = &H90     '=144A]w}l񪺺X
Private Const MIDI_EVENT_NOTE_OFF = &H80    '=128A]w񪺺X
Private Const MIDI_STOP_ALL_NOTES = &HB0    '=176A]wҦ񰱤X
Private Const MIDI_CHANGE_ALL_NOTES = &HC0  '=192A]wܩҦ񭵽ժX

'yz Midi ]ƪc
Private Type MidiOutCaps
  wMid As Integer
  wPid As Integer
  vDriverVersion As Long  ' ]ƪ
  szPname As String * 32  ' ]ƦW
  wTechnology As Integer  ' ]
  wVoices As Integer
  wNotes As Integer
  wChannelMask As Integer
  dwSupport As Long
End Type

Private hMidi As Long, midiErr As Long

'oҦPw] Midi X]
Public Function midiDevToList(obj As Control) As Boolean
  Dim i As Integer, midiCaps As MidiOutCaps
  
  obj.Clear
  If midiOutGetDevCaps(midiDefault, midiCaps, Len(midiCaps)) = 0 Then
    'pGo Midi ]Ʀ\Ah[Jw]]ƦW
    obj.AddItem midiCaps.szPname
    obj.ItemData(obj.NewIndex) = midiDefault   'w] Midi ]ƥNX
    midiDevToList = True
  End If
  'bow] Midi ]ƤAAoL Midi ]
  For i = 0 To midiOutGetNumDevs - 1
    If midiOutGetDevCaps(i, midiCaps, Len(midiCaps)) = 0 Then
      obj.AddItem midiCaps.szPname
      obj.ItemData(obj.NewIndex) = i
      midiDevToList = True
    End If
  Next
End Function

'HwѼơA Midi X]
Public Sub midiChangeDev(ByVal devId As Long)
  midiClose
  'Hw Midi ]ƥNXA} Midi ]ơAPɨo hMidi
  midiErr = midiOutOpen(hMidi, devId, 0, 0, 0)
  If midiErr <> 0 Then midiErrMsg midiErr
End Sub

'bϥΪ Midi X]
Public Sub midiClose()
  If hMidi <> 0 Then
    midiErr = midiOutClose(hMidi)
    If midiErr <> 0 Then midiErrMsg midiErr
    hMidi = 0
  End If
End Sub

'HwѼơA Midi 
'ѼƤOqDsAաAtס]utסv۹ﱱF񭵶qPɶ^
Public Sub keyOn(channel As Long, ByVal note As Long, ByVal velocity As Long)
  midiPlay MIDI_EVENT_NOTE_ON + channel, note, velocity
End Sub

'e@ Midi ż
Public Sub keyOff(channel As Long, ByVal note As Long)
  'velocity = 0
  midiPlay MIDI_EVENT_NOTE_OFF + channel, note, 0
End Sub

'V Midi X]ƵoeuT
Private Sub midiPlay(channel As Long, note As Long, velocity As Long)
  midiErr = midiOutShortMsg(hMidi, channel + note * &H100 + velocity * &H10000)
  If midiErr <> 0 Then midiErrMsg midiErr
End Sub

'HwѼơAܺt־
Public Sub midiChangeSound(channel As Long, ByVal noteSound As Long)
  midiPlay MIDI_STOP_ALL_NOTES + channel, 0, 0
  midiPlay MIDI_CHANGE_ALL_NOTES + channel, noteSound, 0
End Sub

'o Midi X]ƪ~T
Private Sub midiErrMsg(ByVal midiErr As Long)
  Dim s As String, d As Long

  s = String(maxErrorLength, 0)
  d = midiOutGetErrorText(midiErr, s, maxErrorLength)
  MsgBox s
End Sub
